version: '2.4'

services:

  db:
    image: postgres:{{ pg_version }}-alpine
    restart: unless-stopped
    expose :
      - 9000
      - 5432
    environment:
      - POSTGRES_PASSWORD={{ pg_admin_password }}
      - TZ={{ timezone }}
      - PGTZ={{ timezone }}
    shm_size: {{ db_shm_size }}
    volumes:
      - ./db/live-data:/var/lib/postgresql/data
      - ./db/init:/docker-entrypoint-initdb.d/
      - {{ pg_nc_backupfile }}:/tmp/backup/backup.sql
    networks:
      - internal-db
    command: >
      -c work_mem={{ db_working_memory }}
      -c maintenance_work_mem={{ db_maintenance_working_memory }}
      -c max_wal_size={{ db_max_wal_size }}

    logging: &logging
      driver: "json-file"
      options:
          max-size: "500k"
          max-file: "10"

  collabora:
    image: collabora/code:{{ collabora_version }}
    restart: unless-stopped
    expose:
      - 9980
    networks:
      - web
    environment:
      - "extra_params=--o:ssl.enable=false  --o:ssl.termination=true"
      - domain={{ nc_domain }}
      - TZ={{ timezone }}
    labels:
      - "traefik.enable=true"
      - "traefik.docker.network=web"
      - "traefik.http.routers.{{ nc_name }}-collabora.entrypoints=websecure"
      - "traefik.http.routers.{{ nc_name }}-collabora.rule=Host(`{{ collabora_domain }}`)"
      - "traefik.http.routers.{{ nc_name }}-collabora.tls.certresolver=httpsresolver"
      - "traefik.http.services.{{ nc_name }}-collabora.loadbalancer.server.port=9980"
    logging:
      <<: *logging

  redis:
    image: redis:{{ redis_version }}-alpine
    restart: unless-stopped
    command: "redis-server --requirepass {{ redis_nc_password }}"
    environment:
      - TZ={{ timezone }}

    expose:
      - 6379
    networks:
      - internal-fpm
    logging:
      <<: *logging

  imaginary:
    image: nextcloud/aio-imaginary:{{ imaginary_version }}
    environment:
      - TZ={{ timezone }}
    stop_grace_period: 10s
    restart: unless-stopped
    networks:
      - internal-fpm
    logging:
      <<: *logging

  app:
    image: nextcloud:local-{{ nextcloud_version }}
    build: ./nextcloud
    restart: unless-stopped
    networks:
      - internal-fpm
      - internal-db
    volumes:
      - {{ nc_data }}:/var/www/html/
    environment:
      - REDIS_HOST=redis
      - REDIS_HOST_PORT=6379
      - REDIS_HOST_PASSWORD={{ redis_nc_password }}
      - POSTGRES_DB={{ pg_nc_dbname }}
      - POSTGRES_HOST=db
      - POSTGRES_USER={{ pg_nc_user }}
      - POSTGRES_PASSWORD={{ pg_nc_password }}
      - NEXTCLOUD_ADMIN_USER={{ nc_admin_user }}
      - NEXTCLOUD_ADMIN_PASSWORD={{ nc_admin_password }}
      - NEXTCLOUD_TRUSTED_DOMAINS={{ nc_domain }}
      - TZ={{ timezone }}
      - IMAGINARY_ENABLED=true
      - IMAGINARY_HOST=imaginary
      - PHP_UPLOAD_LIMIT={{ nc_upload_limit }}
      - PHP_MEMORY_LIMIT={{ php_memory_limit }}
      - OPCACHE_MEM_SIZE=256
    depends_on:
      - db
      - redis
    logging:
      <<: *logging

  cron:
    image: nextcloud:local-{{ nextcloud_version }}
    build: ./nextcloud
    restart: unless-stopped
    environment:
      - TZ={{ timezone }}
    networks:
      - internal-fpm
      - internal-db
    volumes:
      - {{ nc_data }}:/var/www/html/
    depends_on:
      - db
      - redis
      - app
    entrypoint: /cron.sh
    logging:
      <<: *logging


  web:
    build: ./web
    restart: unless-stopped
    volumes_from:
      - app
    environment:
      - VIRTUAL_HOST={{ nc_domain }}
      - TZ={{ timezone }}
    depends_on:
      - app
    expose:
      - 80
    networks:
      - web
      - internal-fpm
    labels:
      - "traefik.enable=true"
      - "traefik.docker.network=web"
      - "traefik.http.routers.{{ nc_name }}.entrypoints=websecure"
      - "traefik.http.routers.{{ nc_name }}.rule=Host(`{{ nc_domain }}`)"
      - "traefik.http.routers.{{ nc_name }}.tls.certresolver=httpsresolver"
      - "traefik.http.services.{{ nc_name }}.loadbalancer.server.port=80"
      - "traefik.http.routers.{{ nc_name }}.middlewares=nextcloud_redirectregex"
      - "traefik.http.middlewares.nextcloud_redirectregex.redirectregex.permanent=true"
      - "traefik.http.middlewares.nextcloud_redirectregex.redirectregex.regex=https://(.*)/.well-known/(?:card|cal)dav"
      - "traefik.http.middlewares.nextcloud_redirectregex.redirectregex.replacement=https://$${1}/remote.php/dav"
    logging:
      <<: *logging

networks:
  internal-fpm:
  internal-db:
  web:
    external: true